/*

                                      +-----+
         +----[PWR]-------------------| USB |--+
         |                            +-----+  |
         |           GND/RST2  [ ] [ ]         |
         |         MOSI2/SCK2  [ ] [ ]  SCL[ ] |   C5
         |            5V/MISO2 [ ] [ ]  SDA[ ] |   C4
         |                             AREF[ ] |
         |                              GND[ ] |
         | [ ]N/C                    SCK/13[A] |   B5
         | [ ]v.ref                 MISO/12[A] |   .
   *)    | [ ]RST                   MOSI/11[A]~|   .    TRX2 **)
         | [ ]3V3    +---+               10[ ]~|   .    TRX1
         | [ ]5v     | A |                9[ ]~|   .	ANT8
         | [ ]GND   -| R |-               8[B] |   B0	ANT7
         | [ ]GND   -| D |-                    |
         | [ ]Vin   -| U |-               7[A] |   D7	ANT6
         |          -| I |-               6[A]~|   .	ANT5
         | [ ]A0    -| N |-               5[C]~|   .	ANT4
         | [ ]A1    -| O |-               4[A] |   .	ANT3
         | [ ]A2     +---+           INT1/3[A]~|   .	ANT2
         | [ ]A3                     INT0/2[ ] |   .	ANT1
         | [ ]A4      RST SCK MISO     TX>1[ ] |   .
         | [ ]A5      [ ] [ ] [ ]      RX<0[ ] |   D0
         |            [ ] [ ] [ ]              |
         |  UNO_R3    GND MOSI 5V  ____________/
          \_______________________/

	*)  erst nach Programmieren
           10k von Reset-Pin an +5V
           100n von Reset-Pin an GND

        **) Optokoppler für Ant-Rel
*/
/*
Antennen-Umschaltung - TRX1 / TRX2
Auswahl von bis zu 8 Antennen
Steuerung durch UCXLog ( Other Interfaces Microham Band Data )
Anschaltung der Antennenrelais über Optokoppler
(c)DL8DWW, 22.12.2019
*/
//Pins für Ansteuerung der Optokoppler gegen GND
int ant1 = 2; // Antenne 1:
int ant2 = 3; // Antenne 2:
int ant3 = 4; // Antenne 3:
int ant4 = 5; // Antenne 4:
int ant5 = 6; // Antenne 5:
int ant6 = 7; // Antenne 6:
int ant7 = 8; // Antenne 7:
int ant8 = 9; // Antenne 8:
int trx1 = 10; // TRX_1
int trx2 = 11;// TRX_2
//-----------------------------------------------
char inChar = 0; //Byte von String:
String inString = ""; // string to hold input:
String W_ANT;
int x;
int y;
//+++++++++++++++++++++++++++++++++++++++++++++++
void setup()
{
  Serial.begin(9600); //Open serial communications and wait for port to open:
  while (!Serial);
  {
    //Pins als Ausgang für Relaisansteuerung:
    pinMode(ant1, OUTPUT);
    pinMode(ant2, OUTPUT);
    pinMode(ant3, OUTPUT);
    pinMode(ant4, OUTPUT);
    pinMode(ant5, OUTPUT);
    pinMode(ant6, OUTPUT);
    pinMode(ant7, OUTPUT);
    pinMode(ant8, OUTPUT);
    pinMode(trx1, OUTPUT);
    pinMode(trx2, OUTPUT);
    digitalWrite(ant1, LOW);
    digitalWrite(ant2, LOW);
    digitalWrite(ant3, LOW);
    digitalWrite(ant4, LOW);
    digitalWrite(ant5, LOW);
    digitalWrite(ant6, LOW);
    digitalWrite(ant7, LOW);
    digitalWrite(ant8, LOW);
    digitalWrite(trx1, LOW);
    digitalWrite(trx2, LOW);
  }
}
void loop()
{
  // Read serial input:
   
  while (Serial.available() > 0)
  {
    int inChar = Serial.read();
    {
      // Byte an das Ende vom String:
      inString += (char)inChar;
    }
     W_ANT=inString.substring(0,3);
  //+++++++++++++++++++++++++++++++++++++++++:   
    if (inString=="FT1" or W_ANT=="AS1")
     {
    digitalWrite(trx2, LOW); //   TRX 2:
    digitalWrite(trx1, HIGH); //  TRX 1:
  // ++++++++++++++++++++++++++++++++++++++++:
    // Bandzuordnung der Antennen fuer TRX 1:    
    if (inString == "AS100") // Antenne 1: 
    {
      x = 100; 
    }          
    if (inString == "AS101") // Antenne 2: 
    {
      x = 101; 
    }           
    if (inString == "AS102") // Antenne 3: 
    {
      x = 102; 
    }          
    if (inString == "AS103") // Antenne 4: 
    {
      x = 103; }      
    if (inString == "AS104") // Antenne 5: 
    {
      x = 104; }   
    if (inString == "AS105") // Antenne 6: 
    {
      x = 105;
    }         
    if (inString == "AS106") // Antenne 7: 
    {
      x = 106; 
    }         
    if (inString == "AS107")  // Antenne 8:
    {
     x = 107; 
    }
  //++++++++++++++++++++++++++++++++++++++:  
   if (x ==100) 
   {
      digitalWrite(ant1, HIGH);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);    
    }
    if (x == 101)  // Antenne 2: 
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, HIGH);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (x == 102)  // Antenne 3:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, HIGH);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);  
    }
    if (x == 103)  // Antenne 4:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, HIGH);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (x == 104)  // Antenne 5:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, HIGH);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (x == 105)  // Antenne 6:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, HIGH);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (x == 106)  // Antenne 7:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, HIGH);
      digitalWrite(ant8, LOW);
    }
    if (x == 107)  // Antenne 8:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, HIGH);    
    }  
   }   
  //+++++++++++++++++++++++++++++++++++++++:
   if (inString=="FT2" or W_ANT=="AS2")
    {
    digitalWrite(trx1, LOW); //   TRX 1:
     digitalWrite(trx2, HIGH); //  TRX 2:     
   // ++++++++++++++++++++++++++++++++++++++:   
    // Bandzuordnung der Antennen fuer TRX 2:    
    if (inString == "AS200") // Antenne 1: 
    {
      y = 200;
    }    
    if (inString == "AS201") // Antenne 2: 
    {  
      y = 201;
    }   
    if (inString == "AS202") // Antenne 3: 
    {
      y = 202;
    }
    if (inString == "AS203") // Antenne 4: 
    {
     y = 203;
    }  
    if (inString == "AS204") // Antenne 5: 
    {
      y = 204;
    }    
    if (inString == "AS205")  // Antenne 6:
    {
      y = 205;
    }   
    if (inString == "AS206")  // Antenne 7: 
    {
      y = 206;
    }    
    if (inString == "AS207")  // Antenne 8:
    {
      y = 207;
    }
  //++++++++++++++++++++++++++      
     if (y ==200) //Antenne 1
   {
      digitalWrite(ant1, HIGH);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);    
    }
    if (y == 201)  // Antenne 2: 
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, HIGH);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (y == 202)  // Antenne 3:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, HIGH);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);  
    }
    if (y == 203)  // Antenne 4:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, HIGH);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (y == 204)  // Antenne 5:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, HIGH);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (y == 205)  // Antenne 6:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, HIGH);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, LOW);
    }
    if (y == 206)  // Antenne 7:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, HIGH);
      digitalWrite(ant8, LOW);
    }
    if (y == 207)  // Antenne 8:
    {
      digitalWrite(ant1, LOW);
      digitalWrite(ant2, LOW);
      digitalWrite(ant3, LOW);
      digitalWrite(ant4, LOW);
      digitalWrite(ant5, LOW);
      digitalWrite(ant6, LOW);
      digitalWrite(ant7, LOW);
      digitalWrite(ant8, HIGH);    
    }
 //++++++++++++++++++++++++++++   
  } 
 // ist Stringende erreicht,
 // then the string's value
    if (inChar == '\n')
    {
   // Monitoranzeige für Test:
      Serial.println(inString);
   // Serial.println(W_ANT);
      Serial.println (x);
      Serial.println (y);
    }
  }
  //String für neuen Input leeren:
  inString = "";
    delay(250);
}

